let sessionNumber = 29;
require('geckodriver');
// Generated by Selenium IDE
const { Builder, By, Key, until } = require('selenium-webdriver')
const firefox = require('selenium-webdriver/firefox');
const { performance } = require('perf_hooks');
const assert = require('assert');
const fs = require('fs');
const path = require('path');
const chai = require('chai');
const expect = chai.expect;

const data = fs.readFileSync('./test/grading.json');
const jsonData = JSON.parse(data);
const { WebDriverWait } = require('selenium-webdriver');

if(!jsonData.gradedTest.s29){

	try {

        if (!fs.existsSync('./sessions/backend/s29/discussion/index.html')) {
            throw new Error('File not found');
        }
		// Variable to store passing unit test scores for the session
		let passingTests = 0;
		// Variable to store total number of session unit tests
		let totalTests = 0;
			

		describe(`s${sessionNumber}`, function () {

			this.timeout(30000);

			let driver;
			let vars;
		
			let internalCssTestPassed = false;
		
			function parsePixels(value) {
				return parseFloat(value.replace('px', ''));
			}

			let startTime;

            


			before(async function() {

            const options = new firefox.Options();
            options.headless();

            options.setPreference('browser.download.manager.showWhenStarting', false);
            options.setPreference('browser.download.manager.useWindow', false);
            options.setPreference('devtools.netmonitor.enabled', true);

			  startTime = performance.now();
			  // Any setup code you need to run before the tests start
			  driver = await new Builder().forBrowser('firefox').setFirefoxOptions(options).build()

			});


			beforeEach(async function() {

			  totalTests += 1;
			  vars = {}
			})

			afterEach(function(){

				if(this.currentTest.state === "passed"){
					passingTests += 1;
				}

				process.removeAllListeners(); 

			})


            it('should delete and remove post', async function() {

                const filePath = path.join(__dirname, '..','sessions','backend','s29','discussion','index.html');
                const url = `file://${filePath}`;
                await driver.get(url);
                
                // Wait for the page to reload and the new post to be added
                await driver.wait(until.elementLocated(By.id('post-1')), 30000);
            
                // Check if the new post's title is displayed on the page
                const postDelete = await driver.findElement(By.id('post-1')).findElements(By.css("button"))
                await postDelete[1].click();

                try {

                      // Wait for the alert to appear
                      const alert = await driver.wait(until.alertIsPresent(), 5000);

                      // Check the alert text and accept it
                      const alertText = await alert.getText();
                      await alert.accept();
                      expect(alertText.toLowerCase()).to.include('deleted',"Alert message does not tell user post is deleted.");

                      // // Check if the div is no longer present on the page
                      let elements = await driver.findElements(By.css("#post-1"));
                      expect(elements.length).to.equal(0,"Added post is not deleted.")

                } catch (error) {

                  console.log('No alert found.');
                  
                }



              })

              it('should have correct request method', async function() {


                const filePath = path.join(__dirname, '..','sessions','backend','s29','discussion','index.html');
                const url = `file://${filePath}`;
                await driver.get(url);
                
                // Wait for the page to reload and the new post to be added
                await driver.wait(until.elementLocated(By.id('post-2')), 30000);

                // execute the script after navigating to the target page
                const interceptFetchAndReturnMethod = async () => {
                  await driver.executeScript(() => {
                    // save the original fetch function
                    const originalFetch = window.fetch;
                    
                   
                    // create a new fetch function
                    window.fetch = function (url, options) {
                        // log the request method
                        window.reqM = options.method;
                    
                        // call the original fetch function
                        return originalFetch.apply(this, arguments);
                    }

                    });

                };
                
               await interceptFetchAndReturnMethod();
            
                // Check if the new post's title is displayed on the page
                const postDelete = await driver.findElement(By.id('post-2')).findElements(By.css("button"))
                await postDelete[1].click();

                let postMethod =  await driver.executeScript('return window.reqM')

                expect(postMethod).to.include("DELETE","Wrong request method was used.")


              })


              
                // Test the functionality of the delete-all button
                it('should remove div-post-entries contents and show an alert', async function() {
                  // Navigate to the webpage with the delete-all button
                  const filePath = path.join(__dirname, '..','sessions','backend','s29','discussion','index.html');
                  const url = `file://${filePath}`;
                  await driver.get(url);

                  // Find and click the delete-all button
                  const deleteAllButton = await driver.findElement(By.id('delete-all'));
                  await deleteAllButton.click();

                  try {
                    // Wait for the alert to appear
                    const alert = await driver.wait(until.alertIsPresent(), 5000);

                    // Check the alert text and accept it
                    const alertText = await alert.getText();
                    await alert.accept();
                    expect(alertText.toLowerCase()).to.include('deleted',"Alert message does not tell user post is deleted.");

                    // Wait for the contents of div-post-entries to be removed
                    await driver.wait(async function() {
                      const postEntries = await driver.findElement(By.id('div-post-entries'));
                      const innerHTML = await postEntries.getAttribute('innerHTML');
                      return innerHTML === '';
                    });

                    // Verify that the contents of div-post-entries are empty
                    const postEntries = await driver.findElement(By.id('div-post-entries'));
                    const innerHTML = await postEntries.getAttribute('innerHTML');
                    assert.equal(innerHTML, '');

                  } catch (error) {
                    console.log('No alert found.');
                  }

                  // Wait for the alert to be displayed
                  // const alert = await driver.switchTo().alert();
                  // const alertText = await alert.getText();
                  

                  // // Accept the alert
                  // await alert.accept();



                });
              

            after(async function () {

   
                const endTime = performance.now();
                const totalTime = (endTime - startTime) / 1000; // Convert to seconds
                console.log(`Total time taken: ${totalTime} seconds`);
      
                global.gradesObject[`${sessionNumber}`] = {
                  grade: `${passingTests/totalTests >= 0.75 ? "P" : "F"}`,
                  score: `${passingTests}/${totalTests}`
                }
            
                jsonData.gradedTest.s29 = true;
                //await fs.writeFileSync('./test/grading.json', JSON.stringify(jsonData,null,4));
    
                // await driver.close()
                await driver.quit(); 
              });
		});
		
	} catch (err) {
		if(err.code === "MODULE_NOT_FOUND" || err.message === "File not found"){
		  console.error(`s${sessionNumber} cannot be found. Check activity folder.`);
		} else {
		  console.log(err)
		}
	}
} else {
	console.log(`S${sessionNumber} - Tested`);
}


